package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_25_25_AnimationManager extends ActorScript
{
	public var _SlideList:Array<Dynamic>;
	public var _theList:Array<Dynamic>;
	public var _theList2:Array<Dynamic>;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("SlideList", "_SlideList");
		nameMap.set("theList", "_theList");
		nameMap.set("theList2", "_theList2");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.setActorValue("AnimationTimer", 0);
		actor.setActorValue("SwitchAnimationTime", 10000);
		actor.setActorValue("AnimationList", new Array<Dynamic>());
		actor.setActorValue("isBusyAnimating", false);
		actor.setActorValue("isKilled", false);
		actor.setActorValue("nextAnimationActionNR", 0);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 0.02, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				if(((actor.getActorValue("AnimationList") : Array<Dynamic>).length > 0))
				{
					if(!((actor.getActorValue("isKilled") : Bool)))
					{
						
						if(((actor.getActorValue("AnimationList") : Array<Dynamic>)[0] == "kill"))
						{
							actor.setActorValue("isKilled", true);
							(actor.getActorValue("AnimationList") : Array<Dynamic>).splice(0, 1);
							trace((("AnimationListManager :RemoveItem: KILL  objectnr") + ("" + actor.getActorValue("ObjectNR"))));
							if((actor.getType() == getActorType(0)))
							{
								actor.setActorValue("DynamicAnimation", "man.death");
								actor.setX(randomInt(-2000, -5000));
							}
							else
							{
								actor.setX(-1000);
							}
							A3D.stencyl(Engine.engine);A3D.setProperty("" + actor.getActorValue("3DName"),"visible",false);
							A3D.setObject("" + actor.getActorValue("3DName"),null);
							actor.setActorValue("3DName", "nothing");
							actor.setActorValue("ObjectNR", null);
						}
						else
						{
							if((("" + (actor.getActorValue("AnimationList") : Array<Dynamic>)[0]).indexOf("SLIDE") > -1))
							{
								actor.setActorValue("SlideList", ("" + (actor.getActorValue("AnimationList") : Array<Dynamic>)[0]).split(","));
								actor.setActorValue("SlideX", asNumber((actor.getActorValue("SlideList") : Array<Dynamic>)[1]));
								actor.setActorValue("SlideY", asNumber((actor.getActorValue("SlideList") : Array<Dynamic>)[2]));
								actor.setActorValue("SlideTime", asNumber((actor.getActorValue("SlideList") : Array<Dynamic>)[3]));
								trace((("") + ((("" + actor.getActorValue("SlideX")) + (((" y ") + ((("" + actor.getActorValue("SlideY")) + (((" time ") + ((("" + actor.getActorValue("SlideTime")) + ("")))))))))))));
								(actor.getActorValue("AnimationList") : Array<Dynamic>)[0] = "nothing";
								
								actor.moveTo(asNumber(actor.getActorValue("SlideX")), asNumber(actor.getActorValue("SlideY")), asNumber(actor.getActorValue("SlideTime")), Easing.linear);
							}
							else
							{
								if(!(actor.getAnimation() == (actor.getActorValue("AnimationList") : Array<Dynamic>)[0]))
								{
									actor.setAnimation("" + (actor.getActorValue("AnimationList") : Array<Dynamic>)[0]);
									/* "" */ if((actor.getType() == getActorType(0)))
									{
										actor.setActorValue("DynamicAnimation", (("man.") + (actor.getAnimation())));
									}
									if((actor.getType() == getActorType(16)))
									{
										actor.setActorValue("DynamicAnimation", (("zombie.") + (actor.getAnimation())));
									}
									if((actor.getType() == getActorType(14)))
									{
										actor.setActorValue("DynamicAnimation", (("vampire.") + (actor.getAnimation())));
									}
									trace((("Switched to animation: ") + ("" + actor.getActorValue("DynamicAnimation"))));
								}
								actor.setActorValue("AnimationTimer", (asNumber(actor.getActorValue("AnimationTimer")) + 1));
								if((asNumber(actor.getActorValue("AnimationTimer")) > asNumber(actor.getActorValue("SwitchAnimationTime"))))
								{
									trace((("ready with animation and get next animation the old Switched to animation was:") + ("" + actor.getActorValue("DynamicAnimation"))));
									(actor.getActorValue("AnimationList") : Array<Dynamic>).splice(0, 1);
									actor.setActorValue("AnimationTimer", 0);
								}
							}
						}
					}
				}
			}
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}