package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_27_27_AssetLoader extends SceneScript
{
	public var _theList:Array<Dynamic>;
	public var _theColor:Int;
	public var _theList2:Array<Dynamic>;
	public var _theStep:Float;
	public var _theFont:Font;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_loadMD5s():Void
	{
		if(!(((getGameAttribute("isMD5Busy")) : Bool)))
		{
			setGameAttribute("isMD5Busy", true);
			if(!(Utils.mapCount(((getGameAttribute("FileMap")) : Map<String,Dynamic>)) == 0))
			{
				for(item in (((getGameAttribute("FileMap")) : Map<String,Dynamic>) : Map<String,Dynamic>).keys())
				{
					setGameAttribute("LastKey", item);
				}
				setGameAttribute("FileAction", ((getGameAttribute("FileMap")) : Map<String,Dynamic>).get("" + (getGameAttribute("LastKey"))));
				((getGameAttribute("FileMap")) : Map<String,Dynamic>).remove("" + (getGameAttribute("LastKey")));
				setGameAttribute("SeperatorSplit", ("" + (getGameAttribute("FileAction"))).split(";"));
				setGameAttribute("Name", ((getGameAttribute("LastKey")) : Dynamic));
				setGameAttribute("Info", (("Name |") + ((("" + (getGameAttribute("Name"))) + ((("| FileAction |") + ((("" + (getGameAttribute("FileAction"))) + ((("|") + ((("") + ("")))))))))))));
				/* "" */ trace(((getGameAttribute("Info")) : Dynamic));
				_theFont = getFont(2);
				((getGameAttribute("InfoActor")) : Actor).setActorValue("Font", _theFont);
				((getGameAttribute("InfoActor")) : Actor).setActorValue("Text", ((getGameAttribute("Info")) : Dynamic));
				A3D.stencyl(Engine.engine);ResourceLoader.loadResource("" + (getGameAttribute("Name")),"FILE", ((getGameAttribute("FileAction")) : Dynamic), function myLoadFunc(){A3D.stencyl(Engine.engine);ResourceLoader.loadResource((("" + (getGameAttribute("Name"))) + ("Skin")),"FILE", (("" + (getGameAttribute("Path"))) + ((("" + (getGameAttribute("Name"))) + (".png")))), function myLoadFunc(){trace((("Skinfile : ") + ((((("" + (getGameAttribute("Path"))) + ((("" + (getGameAttribute("Name"))) + (".png"))))) + ((("") + (((" loaded ") + ((("(") + ((((("" + (getGameAttribute("Name"))) + ("Skin"))) + (")")))))))))))));
						setGameAttribute("isMD5Busy", false);});});
			}
			else
			{
				setGameAttribute("isReadyToLoad", false);
				setGameAttribute("isMD5Ready", true);
				setGameAttribute("isMD5Busy", false);
			}
		}
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("theList", "_theList");
		nameMap.set("theColor", "_theColor");
		_theColor = Utils.getColorRGB(0,0,0);
		nameMap.set("theList2", "_theList2");
		nameMap.set("theStep", "_theStep");
		_theStep = 0.0;
		nameMap.set("theFont", "_theFont");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		setGameAttribute("isMD5LoadDone", false);
		createRecycledActor(getActorType(3), 0, 0, Script.FRONT);
		setGameAttribute("InfoActor", getLastCreatedActor());
		setGameAttribute("isReadyToLoad", false);
		A3D.isDebug=false;
		setGameAttribute("isReady", false);
		setGameAttribute("Step", 1);
		setGameAttribute("Counter", 0);
		setGameAttribute("isMDLoading", false);
		setGameAttribute("isMD5Busy", false);
		setGameAttribute("isBusyCreate", false);
		trace("Create MD5");
		setGameAttribute("MD5List", new Array<Dynamic>());
		setGameAttribute("Path", "assets/data/");
		setGameAttribute("BackupPath", ((getGameAttribute("Path")) : Dynamic));
		/* "" */ setGameAttribute("FileMap", new Map<String, Dynamic>());
		((getGameAttribute("FileMap")) : Map<String,Dynamic>).set("zombie", (("hit=") + ((("" + (getGameAttribute("Path"))) + ((("hit.md5anim;run=") + ((((("" + (getGameAttribute("Path"))) + ((("zombie_run.md5anim;idle=") + ((("" + (getGameAttribute("Path"))) + ((("zombie_idle.md5anim;attack=") + ((("" + (getGameAttribute("Path"))) + ((("zombie_attack.md5anim;death=") + ((("" + (getGameAttribute("Path"))) + ((("death.md5anim;mesh=") + ((("" + (getGameAttribute("Path"))) + ("zombie.md5mesh;"))))))))))))))))))) + ("")))))))));
		((getGameAttribute("FileMap")) : Map<String,Dynamic>).set("man", (("hit=") + ((("" + (getGameAttribute("Path"))) + ((("hit.md5anim;run=") + ((("" + (getGameAttribute("Path"))) + ((("man_run.md5anim;idle=") + ((("" + (getGameAttribute("Path"))) + ((("man_idle.md5anim;attack=") + ((("" + (getGameAttribute("Path"))) + ((("man_attack.md5anim;death=") + ((("" + (getGameAttribute("Path"))) + ((("man_death.md5anim;mesh=") + ((("" + (getGameAttribute("Path"))) + ("man.md5mesh;")))))))))))))))))))))))));
		((getGameAttribute("FileMap")) : Map<String,Dynamic>).set("vampire", (("hit=") + ((("" + (getGameAttribute("Path"))) + ((("hit.md5anim;run=") + ((("" + (getGameAttribute("Path"))) + ((("v_run.md5anim;idle=") + ((("" + (getGameAttribute("Path"))) + ((("v_idle.md5anim;attack=") + ((("" + (getGameAttribute("Path"))) + ((("v_attack.md5anim;death=") + ((("" + (getGameAttribute("Path"))) + ((("death.md5anim;mesh=") + ((("" + (getGameAttribute("Path"))) + ("v.md5mesh;")))))))))))))))))))))))));
		setGameAttribute("Path", ((getGameAttribute("BackupPath")) : Dynamic));
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 0.1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				if(((getGameAttribute("isMD5Ready")) : Bool))
				{
					/* "" */ setGameAttribute("Info", "                             READY LOADING ALL MD5s");
					trace(((getGameAttribute("Info")) : Dynamic));
					_theFont = getFont(2);
					((getGameAttribute("InfoActor")) : Actor).setActorValue("Font", _theFont);
					((getGameAttribute("InfoActor")) : Actor).setActorValue("Text", ((getGameAttribute("Info")) : Dynamic));
					setGameAttribute("isMD5LoadDone", true);
					switchScene(GameModel.get().scenes.get(1).getID(), null, createCrossfadeTransition(0));
				}
				else
				{
					if(((getGameAttribute("isReadyToLoad")) : Bool))
					{
						_customEvent_loadMD5s();
					}
				}
			}
		}, null);
		
		/* ======================= After N seconds ======================== */
		runLater(1000 * 2, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				setGameAttribute("isReadyToLoad", true);
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}