package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_28_28_MDFive extends SceneScript
{
	public var _theList:Array<Dynamic>;
	public var _theColor:Int;
	public var _theList2:Array<Dynamic>;
	public var _theStep:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Home():Void
	{
		A3D.remove();
		runLater(1000 * 1, function(timeTask:TimedTask):Void
		{
			switchScene(GameModel.get().scenes.get(1).getID(), null, createCrossfadeTransition(0));
		}, null);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_createLight():Void
	{
		trace("Create Light");
		_theList = new Array<Dynamic>();
		_theList.push(-4800);
		_theList.push(-13000);
		_theList.push(92);
		A3D.stencyl(Engine.engine);A3D.createObjectArgs("Light1","DirectionalLight",_theList);
		A3D.stencyl(Engine.engine);A3D.setProperty("Light1","ambient",0.4);
		A3D.stencyl(Engine.engine);A3D.setProperty("Light1","diffuse",0.4);
		_theList = new Array<Dynamic>();
		_theList.push(A3D.getObject("Light1"));
		A3D.stencyl(Engine.engine);A3D.callMethod("Scene0","addChild",_theList);
		_theList = new Array<Dynamic>();
		_theList2 = new Array<Dynamic>();
		_theList2.push(A3D.getObject("Light1"));
		_theList.push(_theList2);
		A3D.stencyl(Engine.engine);A3D.createObjectArgs("Picker1","StaticLightPicker",_theList);
		/* Create a Shadow that is made by the light */
		_theList = new Array<Dynamic>();
		_theList.push(A3D.getObject("Light1"));
		A3D.stencyl(Engine.engine);A3D.createObjectArgs("Shadow1","HardShadowMapMethod",_theList);
		A3D.stencyl(Engine.engine);A3D.setProperty("Shadow1","epsilon",0.08);
		A3D.stencyl(Engine.engine);A3D.setProperty("Shadow1","alpha",0.08);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_createWalls():Void
	{
		/* Textures from:  https://3dtextures.me

Path is set on StartingScene behavior */
		A3D.stencyl(Engine.engine);A3D.createObjectArgs("WallGeometry","CubeGeometry",new Array<Dynamic>());
		A3D.stencyl(Engine.engine);A3D.setProperty("WallGeometry","width",32);
		A3D.stencyl(Engine.engine);A3D.setProperty("WallGeometry","height",32);
		A3D.stencyl(Engine.engine);A3D.setProperty("WallGeometry","depth",80);
		A3D.stencyl(Engine.engine);A3D.setProperty("WallGeometry","depth",48);
		setGameAttribute("File", "wallstructure.png");
		trace("createwalls 3D");
		setGameAttribute("WallCounter", 0);
		A3D.stencyl(Engine.engine);ResourceLoader.loadResource("WallNormal","FILE", (("assets/data/") + ("" + (getGameAttribute("File")))), function myLoadFunc(){for(actorOfType in getActorsOfType(getActorType(12)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					if(!((actorOfType.getActorValue("is3DBound") : Bool)))
					{
						actorOfType.setActorValue("is3DBound", true);
						actorOfType.disableActorDrawing();
						A3D.stencyl(Engine.engine);A3D.createObjectArgs((("WallMaterial") + ("" + (getGameAttribute("WallCounter")))),"TextureMaterial",new Array<Dynamic>());
						A3D.stencyl(Engine.engine);A3D.setProperty((("WallMaterial") + ("" + (getGameAttribute("WallCounter")))),"texture",A3D.getObject("WallNormal"));
						A3D.stencyl(Engine.engine);A3D.setProperty((("WallMaterial") + ("" + (getGameAttribute("WallCounter")))),"lightPicker",A3D.getObject("Picker0"));
						A3D.stencyl(Engine.engine);A3D.setProperty((("WallMaterial") + ("" + (getGameAttribute("WallCounter")))),"shadowMethod",A3D.getObject("Shadow0"));
						A3D.stencyl(Engine.engine);A3D.setProperty((("WallMaterial") + ("" + (getGameAttribute("WallCounter")))),"gloss",20);
						A3D.stencyl(Engine.engine);A3D.createObjectArgs((("Wall") + ("" + (getGameAttribute("WallCounter")))),"Mesh",new Array<Dynamic>());
						A3D.stencyl(Engine.engine);A3D.setProperty((("Wall") + ("" + (getGameAttribute("WallCounter")))),"material",A3D.getObject((("WallMaterial") + ("" + (getGameAttribute("WallCounter"))))));
						A3D.stencyl(Engine.engine);A3D.setProperty((("Wall") + ("" + (getGameAttribute("WallCounter")))),"geometry",A3D.getObject("WallGeometry"));
						/* We set the name to change its animation when the box is on a placeholder */
						actorOfType.setActorValue("3DName", (("Wall") + ("" + (getGameAttribute("WallCounter")))));
						_theList = new Array<Dynamic>();
						_theList.push(A3D.getObject((("Wall") + ("" + (getGameAttribute("WallCounter"))))));
						A3D.stencyl(Engine.engine);A3D.callMethod("Scene0","addChild",_theList);
						/* theObject.x = (A3D.allActors.get(meshName).getX())+((A3D.allActors.get(meshName).getWidth()/32)*12);	 */
						A3D.stencyl(Engine.engine);A3D.setProperty((("Wall") + ("" + (getGameAttribute("WallCounter")))),"x",actorOfType.getX());
						A3D.stencyl(Engine.engine);A3D.setProperty((("Wall") + ("" + (getGameAttribute("WallCounter")))),"y",-(actorOfType.getY()));
						A3D.stencyl(Engine.engine);A3D.setProperty((("Wall") + ("" + (getGameAttribute("WallCounter")))),"z",-6);
						setGameAttribute("WallCounter", (asNumber((getGameAttribute("WallCounter"))) + 1));
					}
				}
			}});
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_createFloor():Void
	{
		A3D.stencyl(Engine.engine);A3D.createObjectArgs("GeoFloor0","PlaneGeometry",new Array<Dynamic>());
		A3D.stencyl(Engine.engine);A3D.setProperty("GeoFloor0","width",(getScreenWidth() * 2));
		A3D.stencyl(Engine.engine);A3D.setProperty("GeoFloor0","height",(getScreenHeight() * 2));
		A3D.stencyl(Engine.engine);A3D.setProperty("GeoFloor0","yUp",false);
		A3D.stencyl(Engine.engine);A3D.createObjectArgs("Floor0","Mesh",new Array<Dynamic>());
		A3D.stencyl(Engine.engine);A3D.setProperty("Floor0","geometry",A3D.getObject("GeoFloor0"));
		setGameAttribute("File", "grass.jpg");
		setGameAttribute("File", "grass.png");
		A3D.stencyl(Engine.engine);ResourceLoader.loadResource("GrassTexture","FILE", (("" + (getGameAttribute("Path"))) + ("" + (getGameAttribute("File")))), function myLoadFunc(){A3D.stencyl(Engine.engine);A3D.createObjectArgs("MatFloor0","TextureMaterial",new Array<Dynamic>());
			A3D.stencyl(Engine.engine);A3D.setProperty("MatFloor0","texture",A3D.getObject("GrassTexture"));
			A3D.stencyl(Engine.engine);A3D.setProperty("MatFloor0","lightPicker",A3D.getObject("Picker0"));
			A3D.stencyl(Engine.engine);A3D.setProperty("MatFloor0","shadowMethod",A3D.getObject("Shadow0"));
			A3D.stencyl(Engine.engine);A3D.setProperty("MatFloor0","gloss",20);
			A3D.stencyl(Engine.engine);A3D.setProperty("MatFloor0","gloss",5);
			A3D.stencyl(Engine.engine);A3D.setProperty("Floor0","material",A3D.getObject("MatFloor0"));
			_theList = new Array<Dynamic>();
			_theList.push(A3D.getObject("Floor0"));
			A3D.stencyl(Engine.engine);A3D.callMethod("Scene0","addChild",_theList);
			A3D.stencyl(Engine.engine);A3D.setProperty("Floor0","x",50);
			A3D.stencyl(Engine.engine);A3D.setProperty("Floor0","y",0);
			A3D.stencyl(Engine.engine);A3D.setProperty("Floor0","z",9);});
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("theList", "_theList");
		nameMap.set("theColor", "_theColor");
		_theColor = Utils.getColorRGB(0,0,0);
		nameMap.set("theList2", "_theList2");
		nameMap.set("theStep", "_theStep");
		_theStep = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		setGameAttribute("3DActorCounter",0);
		setGameAttribute("isCreateWalls",false);
		A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","CameraType","PLATFORM320");
		A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","rotationX",-180);
		A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","x",-1000);
		
		/* ======================= After N seconds ======================== */
		runLater(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				_customEvent_createLight();
				_customEvent_createFloor();
				runLater(1000 * 2, function(timeTask:TimedTask):Void
				{
					setGameAttribute("is3DReady",true);
				}, null);
			}
		}, null);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				setGameAttribute("isFoundWall",false);
				for(actorOfType in getActorsOfType(getActorType(12)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						setGameAttribute("isFoundWall",true);
					}
				}
				if((getGameAttribute("isFoundWall") : Bool))
				{
					if(!((getGameAttribute("isCreateWalls") : Bool)))
					{
						setGameAttribute("isCreateWalls",true);
						_customEvent_createWalls();
					}
				}
			}
		}, null);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 0.1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				for(actorInGroup in cast(getActorGroup(4), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if(!((actorInGroup.getActorValue("is3DBound") : Bool)))
						{
							actorInGroup.setActorValue("is3DBound", true);
							if((actorInGroup.getType() == getActorType(14)))
							{
								setGameAttribute("Type", "vampire");
							}
							if((actorInGroup.getType() == getActorType(16)))
							{
								setGameAttribute("Type", "zombie");
							}
							if((actorInGroup.getType() == getActorType(0)))
							{
								setGameAttribute("Type", "man");
							}
							setGameAttribute("Animation", "idle");
							actorInGroup.disableActorDrawing();
							trace((("CreateNew name of actor") + ((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + (((" with object: ") + ((("" + (getGameAttribute("Type"))) + (((" getObject: ") + ((("" + A3D.getObject("" + (getGameAttribute("Type")))) + (((" switch animation to : ") + ("" + (getGameAttribute("Animation")))))))))))))))));
							actorInGroup.setActorValue("DynamicAnimation", (((("" + (getGameAttribute("Type"))) + ("."))) + ("" + (getGameAttribute("Animation")))));
							A3D.stencyl(Engine.engine);A3D.createObjectArgs((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + ("Material")),"TextureMaterial",new Array<Dynamic>());
							trace((("Skin Attached:  ") + ((((("" + (getGameAttribute("Type"))) + ("Skin"))) + ((("  loaded from assetloader !! ") + ("")))))));
							A3D.stencyl(Engine.engine);A3D.setProperty((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + ("Material")),"texture",A3D.getObject((("" + (getGameAttribute("Type"))) + ("Skin"))));
							A3D.stencyl(Engine.engine);A3D.setProperty((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + ("Material")),"lightPicker",A3D.getObject("Picker0"));
							A3D.stencyl(Engine.engine);A3D.setProperty((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + ("Material")),"shadowMethod",A3D.getObject("Shadow0"));
							A3D.stencyl(Engine.engine);A3D.setProperty((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + ("Material")),"gloss",20);
							A3D.setObject((("Actor") + ("" + (getGameAttribute("3DActorCounter")))),A3D.getObject("" + (getGameAttribute("Type"))).clone());
							A3D.stencyl(Engine.engine);A3D.setProperty((("Actor") + ("" + (getGameAttribute("3DActorCounter")))),"material",A3D.getObject((((("Actor") + ("" + (getGameAttribute("3DActorCounter"))))) + ("Material"))));
							if((actorInGroup.getActorValue("Direction") == null))
							{
								actorInGroup.setActorValue("Direction", 0);
							}
							A3D.stencyl(Engine.engine);Bind.Actor(actorInGroup,(("Actor") + ("" + (getGameAttribute("3DActorCounter"))))); 
							if((getGameAttribute("Type") == "zombie"))
							{
								A3D.stencyl(Engine.engine);A3D.setProperty((("Actor") + ("" + (getGameAttribute("3DActorCounter")))),"z",-6);
							}
							else
							{
								A3D.stencyl(Engine.engine);A3D.setProperty((("Actor") + ("" + (getGameAttribute("3DActorCounter")))),"z",-4);
							}
							actorInGroup.setActorValue("3DName", (("Actor") + ("" + (getGameAttribute("3DActorCounter")))));
							actorInGroup.setAnimation("" + (getGameAttribute("Animation")));
						}
						setGameAttribute("3DActorCounter", (asNumber((getGameAttribute("3DActorCounter"))) + 1));
					}
				}
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}