package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_29_29_FPSCameraControl extends SceneScript
{
	public var _XVar:Float;
	public var _YVar:Float;
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("X", "_XVar");
		_XVar = 0.0;
		nameMap.set("Y", "_YVar");
		_YVar = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		setGameAttribute("isOkToMove",true);
		setGameAttribute("isCorrection",false);
		setGameAttribute("OldPos", 0);
		setGameAttribute("Pos", 0);
		setGameAttribute("CameraMoveCounter", 0);
		setGameAttribute("OldDirection", 0);
		setGameAttribute("Direction", 0);
		setGameAttribute("Step", 90);
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((getGameAttribute("is3DReady") : Bool))
				{
					A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","rotationX",-50);
					/* Set Camera */
					/* "" */ if(!(getGameAttribute("PlayerActor") == null))
					{
						setGameAttribute("Facing", (getGameAttribute("PlayerActor") : Actor).getActorValue("Direction"));
						if((((getGameAttribute("Facing")) : Dynamic) == 90))
				{
					setGameAttribute("Facing", 270);
				}
				else if((((getGameAttribute("Facing")) : Dynamic) == 270))
				{
					setGameAttribute("Facing", 90);
				}
						A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","rotationZ",((getGameAttribute("Facing")) : Dynamic));
						if(((getGameAttribute("PlayerActor") : Actor).getActorValue("Direction") == 0))
						{
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","y",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"y")) - 32));
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","x",A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"x"));
						}
						if(((getGameAttribute("PlayerActor") : Actor).getActorValue("Direction") == 90))
						{
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","x",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"x")) - 32));
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","y",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"y")) - 0));
						}
						if(((getGameAttribute("PlayerActor") : Actor).getActorValue("Direction") == 180))
						{
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","y",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"y")) + 32));
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","x",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"x")) - 0));
						}
						if(((getGameAttribute("PlayerActor") : Actor).getActorValue("Direction") == 270))
						{
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","x",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"x")) + 32));
							A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","y",(asNumber(A3D.getProperty("" + (getGameAttribute("PlayerActor") : Actor).getActorValue("3DName"),"y")) + 0));
						}
						A3D.stencyl(Engine.engine);A3D.setProperty("Camera0","z",-70);
					}
				}
			}
		});
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 0.2, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				if((getGameAttribute("is3DReady") : Bool))
				{
					for(actorInGroup in cast(getActorGroup(4), Group).list)
					{
						if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
							actorInGroup.disableRotation();
							actorInGroup.rotation=0;
							if((actorInGroup.getActorValue("is3DBound") : Bool))
							{
								if(!(asNumber(actorInGroup.getActorValue("ObjectNR")) == (1000 + Colyseus.colyseus.getSeat())))
								{
									A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationX",136);
									A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationY",272);
									if((actorInGroup.getActorValue("Direction") == 90))
									{
										A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",159);
									}
									if((actorInGroup.getActorValue("Direction") == 180))
									{
										A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",423);
									}
									if((actorInGroup.getActorValue("Direction") == 0))
									{
										A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",214);
									}
									if((actorInGroup.getActorValue("Direction") == 270))
									{
										A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",316);
									}
								}
								else
								{
									if((actorInGroup.getActorValue("Direction") == null))
									{
										trace((("Direction is nULL :   ") + ((("" + actorInGroup.getActorValue("Direction")) + (" setting to 0")))));
										actorInGroup.setActorValue("Direction", 0);
									}
									/* TODO  */
									/* Check for OLDDirection change ?? */
									actorInGroup.rotation=0;
									if(!(actorInGroup.getActorValue("Direction") == actorInGroup.getActorValue("OldDirection")))
									{
										actorInGroup.setActorValue("OldDirection", actorInGroup.getActorValue("Direction"));
										A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationX",136);
										A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationY",272);
										if((actorInGroup.getActorValue("Direction") == 90))
										{
											A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",159);
										}
										if((actorInGroup.getActorValue("Direction") == 180))
										{
											A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",63);
										}
										if((actorInGroup.getActorValue("Direction") == 0))
										{
											A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",241);
										}
										if((actorInGroup.getActorValue("Direction") == 270))
										{
											A3D.stencyl(Engine.engine);A3D.setProperty("" + actorInGroup.getActorValue("3DName"),"rotationZ",336);
										}
									}
								}
							}
						}
					}
				}
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}